﻿if not HCoold then return false end
local AceGUI = LibStub("AceGUI-3.0")
local L = HCoold:GetLocale()
local spells = {} -- spells that we can track by system
local spec_spells = {} -- spells that are uniq for each spec of class
local class_talents = {} -- talents for each class
local list_talents = {}
local sybiosis_gain_druid = {}
local sybiosis_gain_raid = {}

--[[
GetSpellInfo
GetSpellLink
GameTooltip
StaticPopupDialogs
StaticPopup_Show
]]--

do -- generate spells list
	do -- generate spells
		local type1 = {------ type == 1  аура на -дамаг +хил
			{ -- дымовая шашка
				spellID = 76577,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "ROGUE",
				cast_time = 7,
				quality = 1,
			},
			{ -- Деморализующий крик
				spellID = 1160,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 60,
				class = "WARRIOR",
				cast_time = 8,
				quality = 1,
			},
			{ -- аура благочестия Devotion Aura
				spellID = 31821,
				class = "PALADIN",
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 1 },
				CD = 180,
				cast_time = 6,
				quality = 1,
			},
			{ -- купол
				spellID = 62618,
				class = "PRIEST",
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 1 },
				CD = 180,
				cast_time = 10,
				quality = 1,
			},
			{ -- тотем шаман
				spellID = 98008,
				class = "SHAMAN",
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 6,
				quality = 3,
			},
			{ -- Ободряющий клич
				spellID = 97462,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 180,
				class = "WARRIOR",
				cast_time = 10,
				quality = 1,
			},
		}
		local type2 = {------ type == 2 аое хил
			{ -- божественный гимн holy
				spellID = 64843,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 2 },
				class = "PRIEST",
				quality = 3,
				cast_time = 8,
			},
			{ -- колодец света
				spellID = 724,
				succ = "SPELL_SUMMON",
				CD = 180,
				specs = { 2 },
				class = "PRIEST",
				trigger = { 126135 },
				quality = 1,
			},
			{ -- спокойствие дру feral
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				specs = { 2, 3, },
				class = "DRUID",
				quality = 1,
				cast_time = 8,
			},
			{ -- спокойствие дру balance
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				specs = { 1 },
				class = "DRUID",
				quality = 2,
				cast_time = 8,
			},
			{ -- спокойствие дру restor
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 4 },
				class = "DRUID",
				quality = 3,
				cast_time = 8,
			},
			{ -- монах Восстановление сил (разовый хил хил всему рейду)
				spellID = 115310,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 180,
				class = "MONK",
				quality = 1,
			},
			{-- тотем целительного прилива
				spellID = 108280,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 10,
				class = "SHAMAN",
				quality = 1,
			},
		}
		local type3 = {------ type == 3 на ману
		}
		local type4 = {------ type == 4  личный кд
			{ -- монах дзен-медитация (-90% урона + 5 кастов на монаха)
				spellID = 115176,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 3 },
				CD = 180,
				cast_time = 8,
				class = "MONK",
				quality = 1,
			},
			{ -- Ярость шамана (энх)
				spellID = 30823,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 60,
				class = "SHAMAN",
				quality = 1,
				cast_time = 15,
			},
			{ -- бабл прист
				spellID = 47585,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 120,
				class = "PRIEST",
				cast_time = 6,
				quality = 1,
			},
			{ -- Ни шагу назад
				spellID = 12975,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				class = "WARRIOR",
				cast_time = 20,
				quality = 1,
			},
			{ -- Бой на смерть (парирование 100%) вар
				spellID = 118038,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 120,
				cast_time = 8,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Глухая оборона прот
				spellID = 871,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 120,
				class = "WARRIOR",
				cast_time = 12,
				quality = 1,
			},
			{ -- Глухая оборона
				spellID = 871,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 300,
				class = "WARRIOR",
				cast_time = 12,
				quality = 1,
			},
			{ -- плащ теней
				spellID = 31224,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "ROGUE",
				cast_time = 5,
				quality = 1,
			},
			{ -- ускользание
				spellID = 5277,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "ROGUE",
				cast_time = 10,
				quality = 1,
			},
			{ -- маг леденая глыба
				spellID = 45438,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 300,
				class = "MAGE",
				cast_time = 10,
				quality = 1,
			},
			{ -- друид дубовая кожа
				spellID = 22812,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2, 3, },
				CD = 60,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- друид дубовая кожа
				spellID = 22812,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 4 },
				CD = 45,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- друид инстинкты выживания (шв)
				spellID = 61336,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2, 3, },
				CD = 180,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- варлок твердая решимость (шв)
				spellID = 104773,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "WARLOCK",
				cast_time = 8,
				quality = 1,
			},
			{ -- паладин ревностный защитник
				spellID = 31850,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 180,
				cast_time = 10,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин бабл
				spellID = 642,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 300,
				cast_time = 8,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин шв
				spellID = 86659,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 120,
				cast_time = 12,
				class = "PALADIN",
				quality = 1,
			},
			{ -- монах закон кармы (мили дамаг в него перевод в цель)
				spellID = 122470,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 90,
				cast_time = 10,
				class = "MONK",
				quality = 1,
			},
			{ -- хант сдерживание
				spellID = 19263,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 5,
				class = "HUNTER",
				quality = 1,
				charges = 2,
			},
			{ -- монах укрепляющий отвар (барскин+ласт стенд)
				spellID = 115203,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 20,
				cast_time = 4,
				class = "MONK",
				quality = 1,
			},
			{ -- дк мини шв
				spellID = 48792,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 12,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк софт кд -20% дамаги
				spellID = 49222,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 60,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк кровь вампира (+хил/хп)
				spellID = 55233,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 60,
				cast_time = 10,
				class = "DEATHKNIGHT",
				quality = 1,
			},
		}
		local type5 = {------ type == 5  точечный кд --------------- !aproved!!aproved!!aproved!!aproved!!aproved!
			{ -- крылья
				spellID = 47788,
				class = "PRIEST",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 3,
				cast_time = 10,
			},
			{ -- пска
				spellID = 33206,
				class = "PRIEST",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 3,
				cast_time = 8,
			},
			{ -- друид железная кора (-дамаг рестор)
				spellID = 102342,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 4 },
				CD = 120,
				class = "DRUID",
				cast_time = 12,
				quality = 1,
			},
			{ -- сакрифайс от не прота
				spellID = 6940,
				class = "PALADIN",
				specs = { 1, 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				cast_time = 12,
			},
			{ -- сакрифайс от прота
				spellID = 6940,
				class = "PALADIN",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 2,
				cast_time = 12,
			},
			{ -- паладин боп
				spellID = 1022,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 300,
				cast_time = 10,
				class = "PALADIN",
				quality = 1,
			},
			{ -- монах Исцеляющий кокон (директ кд на -х дамага и +хил с хотов)
				spellID = 116849,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 120,
				cast_time = 12,
				class = "MONK",
				quality = 1,
			},
		}
		local type6 = {------ type == 6  кд на +дамаг
			{ -- Тотем элема огня !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 2894,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 60,
			},
			{ -- Тотем элементаля земли !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 2062,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 60,
			},
			{ -- войско мертвых дк
				spellID = 42650,
				class = "DEATHKNIGHT",
				specs = { 1, 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 600,
				cast_time = 44,
			},
			{ -- войско мертвых дк нечестивость
				spellID = 42650,
				class = "DEATHKNIGHT",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 540,
				cast_time = 44,
			},
			{ -- шаман бл  !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 2825,  -- за аликов 32182
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "SHAMAN",
				quality = 3,
				cast_time = 40,
				trigger = { 32182, },
			},
			{ -- маг бл
				spellID = 80353,
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "MAGE",
				quality = 3,
				cast_time = 40,
			},
			{ -- варлок призыв инфернала
				spellID = 1122,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 600,
				trigger = { 18540, },
				class = "WARLOCK",
				cast_time = 60,
				quality = 1,
			},
		}
		local type7 = {------ type == 7  возрождения -- SPELL_RESURRECT  ????
			{ -- возрождение Дру
				spellID = 20484,
				succ = "SPELL_RESURRECT", -- SPELL_RESURRECT
				specs = { 0 },
				CD = 600,
				class = "DRUID",
				quality = 3,
			},
			{ -- возрождение ДК
				spellID = 61999,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 600,
				class = "DEATHKNIGHT",
				quality = 2,
			},
			{ -- воскрешение камнем души
				spellID = 20707,
				succ = { "SPELL_CAST_START" }, --{ "SPELL_RESURRECT", "SPELL_AURA_APPLIED" },
				specs = { 0 },
				CD = 900,
				class = "WARLOCK",
				quality = 1,
			},
		}
		local type8 = {------ type == 8  прочее
			----------------- Шаманы
			{ -- Spirit walk (энх фридом)
				spellID = 58875,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 60,
				class = "SHAMAN",
				cast_time = 15,
				quality = 1,
			},
			{ -- благосклонность предков (касты на ходу у шамана)
				spellID = 79206,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "SHAMAN",
				cast_time = 15,
				quality = 1,
			},
			{ -- очищение духа (не рестор шаман)
				spellID = 51886,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 8,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- очищение духа (рестор шаман)
				spellID = 77130,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 8,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- пронизывающий ветер (сбитие каста шаман)
				spellID = 57994,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 12,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- сглаз (лягушка шаман)
				spellID = 51514,
				succ = {"SPELL_AURA_REFRESH", "SPELL_AURA_APPLIED", },
				specs = { 0 },
				CD = 45,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- тотем трепета шаман
				spellID = 8143,
				succ =  "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "SHAMAN",
				cast_time = 6,
				quality = 1,
			},
			{ -- Тотем заземления !aproved!!aproved!!aproved!!aproved!!aproved!
				spellID = 8177,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 25,
				quality = 1,
				cast_time = 15,
			},
			{ -- гром и молния элем
				spellID = 51490,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 45,
				class = "SHAMAN",
				quality = 1,
			},

			----------------- Присты
			{ -- духовое рвение (тянулка прист)
				spellID = 73325,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 90,
				class = "PRIEST",
				quality = 1,
			},
			{ -- защита от страха
				spellID = 6346,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "PRIEST",
				quality = 1,
			},
			{ -- исчадие тьмы
				spellID = 34433,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "PRIEST",
				quality = 1,
				cast_time = 12,
			},
			{ -- масс диспел
				spellID = 32375,
				succ = "SPELL_CAST_START",
				specs = { 0 },
				CD = 15,
				class = "PRIEST",
				quality = 1,
			},
			{ -- диспел
				spellID = 527,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 8,
				class = "PRIEST",
				quality = 1,
			},
			{ -- уход в тень
				spellID = 586,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "PRIEST",
				cast_time = 10,
				quality = 1,
			},
			{ -- архангел диск
				spellID = 81700,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 30,
				class = "PRIEST",
				cast_time = 18,
				quality = 1,
			},
			{ -- щит души диск
				spellID = 109964,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 60,
				class = "PRIEST",
				cast_time = 15,
				quality = 1,
			},
			{ -- объятие вампира
				spellID = 15286,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				class = "PRIEST",
				cast_time = 15,
				quality = 1,
			},

			----------------- Вары
			{ -- Сокрушительный бросок
				spellID = 64382,
				CD = 300,
				specs = { 1, 2 },
				succ = {"SPELL_CAST_SUCCESS", "SPELL_DAMAGE", "SPELL_MISSED" },
				class = "WARRIOR",
				quality = 1,
				-- cast_time = 10,
			},
			{ -- воин издевательское знамя (таунтит мобов на вара)
				spellID = 114192,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 30,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Героический прыжок
				spellID = 52174,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 45,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Зуботычина
				spellID = 6552,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Отражение заклинаний
				spellID = 23920,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				class = "WARRIOR",
				cast_time = 5,
				quality = 1,
			},
			{ -- Рывок
				spellID = 100,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 20,
				class = "WARRIOR",
				quality = 1,
			},

			----------------- Роги
			{ -- исчезновение
				spellID = 1856,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маленькие хитрости
				spellID = 57934,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "ROGUE",
				cast_time = 6,
				quality = 1,
			},
			{ -- пинок
				spellID = 1766,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "ROGUE",
				quality = 1,
			},
			{ -- спринт
				spellID = 2983,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "ROGUE",
				cast_time = 8,
				quality = 1,
			},

			----------------- Маги
			{ -- маг антимагия (сало)
				spellID = 2139,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 24,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг глубокая заморозка
				spellID = 44572,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг невидимость
				spellID = 66,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 300,
				class = "MAGE",
				cast_time = 23,
				quality = 1,
			},
			{ -- маг прилив сил
				spellID = 12051,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг скачок
				spellID = 1953,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг диспел
				spellID = 475,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 8,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг дыхание дракона
				spellID = 31661,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 20,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг призыв пета фростом
				spellID = 31687,
				succ = "SPELL_SUMMON",
				specs = { 3 },
				CD = 60,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг леденая сфера
				spellID = 84714,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 60,
				cast_time = 10,
				class = "MAGE",
				quality = 1,
			},

			----------------- Друид
			{ -- природная стремительность
				spellID = 132158,
				succ = "SPELL_AURA_REMOVED",
				specs = { 1, 4 },
				class = "DRUID",
				CD = 60,
				quality = 1,
			},
			{ -- друид порыв
				spellID = 1850,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- друид тревожный рев
				spellID = 77764,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "DRUID",
				trigger = { 106898, },
				cast_time = 8,
				quality = 1,
			},
			{ -- друид звездопад баланс
				spellID = 48505,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 90,
				class = "DRUID",
				quality = 1,
			},
			{ -- друид снятие порчи (не рестор)
				spellID = 2782,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2, 3, },
				CD = 8,
				class = "DRUID",
				quality = 1,
			},
			{ -- друид столп солнечного света (сбитие каста)
				spellID = 78675,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "DRUID",
				cast_time = 8,
				quality = 1,
			},
			{ -- друид берсерк (котэ+мэдвед)
				spellID = 106951,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2, 3, },
				CD = 180,
				trigger = { 50334, },
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- друид диспел рестор
				spellID = 88423,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 4 },
				CD = 8,
				class = "DRUID",
				quality = 1,
			},

			----------------- Варлок
			{ -- варлок телепортация
				spellID = 48020,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок раскол души
				spellID = 29858,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок ритуал призыва
				spellID = 698,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок создание источника душ
				spellID = 29893,
				succ = "SPELL_CREATE",
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок дестро воскрешение пета инста
				spellID = 120451,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 60,
				class = "WARLOCK",
				quality = 1,
			},

			----------------- Паладин
			{ -- паладин божественная защита (-40% магии)
				spellID = 498,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				cast_time = 10,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин божественно покровительство (20% хасты хпалу)
				spellID = 31842,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 180,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин лох
				spellID = 633,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 600,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин фридом
				spellID = 1044,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				cast_time = 6,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин сальва
				spellID = 1038,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин диспел
				spellID = 4987,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 8,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин укор (сбитие каста)
				spellID = 96231,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "PALADIN",
				quality = 1,
			},

			----------------- хантер
			{ -- хант замораживающая ловушка
				spellID = 1499,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 30,
				trigger = { 82941, 13809, 60192 },
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант замораживающая ловушка сурв
				spellID = 1499,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 24,
				trigger = { 82941, 13809, 60192 },
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант осветилеьный выстрел
				spellID = 1543,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 20,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант отрыв
				spellID = 781,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 20,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант перенаправление
				spellID = 34477,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант приказ хозяина (фридом себе)
				spellID = 53271,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 45,
				cast_time = 4,
				class = "HUNTER",
				quality = 1,
			},

			------------------ монах
			{ -- монах встроенная тринка
				spellID = 137562,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 3 },
				CD = 120,
				cast_time = 6,
				class = "MONK",
				quality = 1,
			},
			{ -- монах диспел
				spellID = 115450,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 8,
				class = "MONK",
				quality = 1,
			},
			{ -- монах рука-копье (сбитие каста)
				spellID = 116705,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "MONK",
				quality = 1,
			},
			{ -- монах удар летящего змея
				spellID = 101545,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 25,
				class = "MONK",
				quality = 1,
			},
			{ -- монах chi wave
				spellID = 115098,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "MONK",
				quality = 1,
			},
			{ -- монах chi burst
				spellID = 123986,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "MONK",
				quality = 1,
			},

			------------------ дк
			{ -- дк антимагический панцирь
				spellID = 48707,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 45,
				cast_time = 5,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк сбитие каста
				spellID = 47528,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк хваталка
				spellID = 49576,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк призыв горгульи
				spellID = 49206,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 30,
				class = "DEATHKNIGHT",
				quality = 1,
			},
		}
		local type9 = {--  type == 9  пвп кулдауны на контроль
			{ -- паладин слепящий свет
				spellID = 115750,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "PALADIN",
				quality = 1,
			},
			{ -- стан прист
				spellID = 64044,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 45,
				class = "PRIEST",
				quality = 1,
			},
			{ -- сало прист
				spellID = 15487,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 45,
				class = "PRIEST",
				quality = 1,
				cast_time = 5,
			},
			{ -- Устрашающий крик (фир вара)
				spellID = 5246,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 90,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- ослепление
				spellID = 2094,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маг возгорание
				spellID = 11129,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 45,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг кольцо льда
				spellID = 122,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				class = "MAGE",
				quality = 1,
			},
			{ -- друид ферал циклон
				spellID = 33786,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2, 3 },
				CD = 20,
				class = "DRUID",
				quality = 1,
			},

			{ -- дк сало
				spellID = 47476,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- паладин стан
				spellID = 853,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "PALADIN",
				quality = 1,
			},
		}
		local type10 = {-- type == 10 кулдауны личные на +дамаг
			{ -- Дух дикого волка энх
				spellID = 51533,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 120,
				cast_time = 15,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- Ярость берсерка
				spellID = 18499,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "WARRIOR",
				cast_time = 6,
				quality = 1,
			},
			{ -- Безрассудство
				spellID = 1719,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 300,
				class = "WARRIOR",
				cast_time = 12,
				quality = 1,
			},
			{ -- Вендетта
				spellID = 79140,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 120,
				class = "ROGUE",
				cast_time = 20,
				quality = 1,
			},
			{ -- Выброс адреналина
				spellID = 13750,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 180,
				class = "ROGUE",
				cast_time = 15,
				quality = 1,
			},
			{ -- Череда убийств
				spellID = 51690,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 120,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маг мощь тайной магии
				spellID = 12042,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 90,
				class = "MAGE",
				cast_time = 15,
				quality = 1,
			},
			{ -- маг стылая кровь фрост
				spellID = 12472,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 20,
				class = "MAGE",
				quality = 1,
			},
			{ -- друид парад планет (+dmg)
				spellID = 112071,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 180,
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- варлок афли +30% хасты
				spellID = 113860,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 120,
				cast_time = 20,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок демон +искусность
				spellID = 113861,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 120,
				cast_time = 20,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок дестро +крит
				spellID = 113858,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 120,
				cast_time = 20,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- паладин крылья
				spellID = 31884,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 180,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин крылья
				spellID = 31884,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 120,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- хант быстрая стрельба
				spellID = 3045,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 15,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант бм+дамаг
				spellID = 19574,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 60,
				cast_time = 10,
				class = "HUNTER",
				quality = 1,
			},
			{ -- дк Ледяной столп (+сила фросту)
				spellID = 51271,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 60,
				cast_time = 20,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- шаман Перерождение
				spellID = 114049,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 15,
				trigger = { 114050, 114051, 114052 },
				class = "SHAMAN",
				quality = 1,
			},
		}
		local type11 = { -- type == 11 просто рандомный бред
		}

		local shok = { -- для отладки
			spellID = 6673, -- ID спелла
			class = "WARRIOR", -- класс, которому принадлежит спелл
			CD = 12, -- кулдаун в секундах у спела
			specs = { 0 },
			succ = "SPELL_CAST_SUCCESS", -- тип ивента, который означает удачное применение , возможен вариант массива { "SPELL_HEAL", "SPELL_AURA_APPLIED" }
			type = 1,  --[[ тип спелла:
					1 - аура на -дамаг (купол, мастер аур и тд)
					2 - аое хил (гимн пристов, транквил)
					3 - на ману (иннеры, гимн на ману, мана тайд)
					4 - личный кд (айс блок, шв, бабл, отражение)
					5 - точечный кд (пс, крылья, придание сил)
					6 - кд на +дамаг (варовский -армор, бл)
					7 - возрождения (друид, шаман, дк, лок)
					8 - прочие кд
					9 - кулдауны на контроль (приоритет на пвп)
					10 - кулдауны личные на +дамаг
				]]
			trigger = { 6673, }, -- дополнительные ид с которых триггерится ивент
			cast_time = 0, -- время действия спелла
			quality = 3, -- качество спелла при сортировке 1/nil - плохое 2 - хорошее 3 - лучшее
			charges = 20, -- количество зарядов спелла
		}

		local bad_spells = 0;
		local function formArray(arr, t)
		    for _, i in next, arr do
			    if (select(1, GetSpellInfo(i.spellID)) ~= nil) then
				    i.type = t
					table.insert(spells, i)
				else
					bad_spells = bad_spells + 1
					HCoold:Printf("   bad spell id = %d", i.spellID)
				end
			end
		end

		formArray(type1, 1)
		formArray(type2, 2)
		formArray(type3, 3)
		formArray(type4, 4)
		formArray(type5, 5)
		formArray(type6, 6)
		formArray(type7, 7)
		formArray(type8, 8)
		formArray(type9, 9)
		formArray(type10, 10)
		HCoold:Printf("Found %d old spells in common spells", bad_spells)
		HCoold.config.types_amount = 10

		if HCoold.debug then table.insert(spells,shok) end
	end

	do -- generate list_talents
		local list_paladin = {
			-- paladin
			[85499] = { -- скорость света
				spellID = 85499,
				class = "PALADIN",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				cast_time = 8,
				quality = 1,
			},
			[105593] = { -- кулак правосудия
				spellID = 105593,
				class = "PALADIN",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				trigger = { 853 },
				quality = 1,
			},
			[20925] = { -- щит небес
				spellID = 20925,
				class = "PALADIN",
				CD = 6,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[114039] = { -- длань очищения
				turn_on = true,
				spellID = 114039,
				class = "PALADIN",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 5,
				-- trigger = {},
				cast_time = 6,
				quality = 1,
			},
			[105809] = { -- святой каратель
				spellID = 105809,
				class = "PALADIN",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				-- trigger = {},
				cast_time = 18,
				quality = 1,
			},
			[20066] = { -- покаяние
				spellID = 20066,
				class = "PALADIN",
				CD = 15,
				succ = "SPELL_AURA_APPLIED",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[115750] = { -- Слепящий свет
				spellID = 115750,
				class = "PALADIN",
				CD = 120,
				succ = "SPELL_AURA_APPLIED",
				type = 9,
				cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[114165] = { -- божественная призма
				spellID = 114165,
				class = "PALADIN",
				CD = 20,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[114158] = { -- молот света
				spellID = 114158,
				class = "PALADIN",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[114157] = { -- смертный приговор
				spellID = 114157,
				class = "PALADIN",
				CD = 60,
				succ = "SPELL_AURA_APPLIED",
				cast_time = 10,
				type = 8,
				trigger = { 114917, 114916 },
				quality = 1,
			},
		}
		local list_druid = {
			[102280] = { -- астральный скачок
				spellID = 102280,
				class = "DRUID",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[102359] = { -- Массовое оплетение
				spellID = 102359,
				class = "DRUID",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				quality = 1,
			},
			[99] = { -- дезориентирующий рык
				spellID = 99,
				class = "DRUID",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				quality = 1,
			},
			[108238] = { -- обновление
				spellID = 108238,
				class = "DRUID",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[132469] = { -- тайфун
				spellID = 132469,
				class = "DRUID",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				trigger = { 61391 },
				quality = 1,
			},
			[102793] = { -- вихрь урсола
				spellID = 102793,
				class = "DRUID",
				CD = 60,
				cast_time = 10,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				quality = 1,
			},
			[5211] = { -- мощное оглушение
				spellID = 5211,
				class = "DRUID",
				CD = 50,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				quality = 1,
			},
			[102351] = { -- щит кенария
				spellID = 102351,
				class = "DRUID",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[102401] = { -- стремительный рывок
				spellID = 102401,
				class = "DRUID",
				CD = 15,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				trigger = {16979, 49376, 102417, 102383, 102416},
				quality = 1,
			},
			[108292] = { -- сердце дикой природы
				spellID = 108292,
				class = "DRUID",
				CD = 360,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				trigger = { 108293, 108291, 108294 },
				cast_time = 45,
				quality = 1,
			},
			[124974] = { -- природная чуткость
				spellID = 124974,
				class = "DRUID",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				trigger = {},
				cast_time = 30,
				quality = 1,
			},
			[155835] = { -- страж
				spellID = 155835,
				class = "DRUID",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				trigger = {},
				cast_time = 3,
				quality = 1,
			},
		}
		local list_priest = {
			[108920] = { -- щупальца бездны
				spellID = 108920,
				class = "PRIEST",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				quality = 1,
			},
			[121536] = { -- божественно перышко
				spellID = 121536,
				class = "PRIEST",
				CD = 10,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[123040] = { -- подчиняющий разум (пет)
				spellID = 123040,
				class = "PRIEST",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				trigger = { 34433 },
				quality = 1,
			},
			[19236] = { -- молитва отчаяния
				spellID = 19236,
				class = "PRIEST",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[10060] = { -- придание сил
				spellID = 10060,
				class = "PRIEST",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				-- trigger = {},
				cast_time = 20,
				quality = 1,
			},
			[112833] = { -- призрачный облик
				spellID = 112833,
				class = "PRIEST",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				cast_time = 6,
				quality = 1,
			},
			[605] = { -- господство над разумом
				spellID = 605,
				class = "PRIEST",
				CD = 30,
				succ = "SPELL_AURA_APPLIED",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[108945] = { -- пассивка божественный оплот
				spellID = 108945,
				class = "PRIEST",
				CD = 90,
				succ = "SPELL_AURA_APPLIED",
				type = 8,
				trigger = { 114214 },
				quality = 1,
			},
			[121135] = { -- каскад
				spellID = 121135,
				class = "PRIEST",
				CD = 25,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[110744] = { -- божественная звезда
				spellID = 110744,
				class = "PRIEST",
				CD = 15,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[120517] = { -- сияние
				spellID = 120517,
				class = "PRIEST",
				CD = 40,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[8122] = { -- ментальный крик прист фир
				spellID = 8122,
				class = "PRIEST",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				quality = 1,
			},
		}
		local list_warlock = {
			[108359] = { -- темное восстановление (хил и +хил аура)
				spellID = 108359,
				class = "WARLOCK",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				-- trigger = {},
				cast_time = 12,
				quality = 1,
			},
			[108416] = { -- жертвенный приговор
				spellID = 108416,
				class = "WARLOCK",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				-- trigger = {},
				cast_time = 10,
				quality = 1,
			},
			[108482] = { -- Свободная воля
				spellID = 108482,
				class = "WARLOCK",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[108501] = { -- гримуар служения
				spellID = 108501,
				class = "WARLOCK",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				trigger = { 111859, 111895, 111896, 111897 },
				cast_time = 20,
				quality = 1,
			},
			[6789] = { -- лик тлена
				spellID = 6789,
				class = "WARLOCK",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[110913] = { -- темная сделка
				spellID = 110913,
				class = "WARLOCK",
				CD = 180,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				-- trigger = {},
				cast_time = 16,
				quality = 1,
			},
			[108503] = { -- гримуар жертвоприношения
				spellID = 108503,
				class = "WARLOCK",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				quality = 1,
			},
			[30283] = { -- неистовство тьмы
				spellID = 30283,
				class = "WARLOCK",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				quality = 1,
			},
			[108508] = { -- Ярость Маннорота
				spellID = 108508,
				class = "WARLOCK",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				cast_time = 10,
				quality = 1,
			},
			[5484] = { -- вой ужаса
				spellID = 5484,
				class = "WARLOCK",
				CD = 40,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				cast_time = 6,
				quality = 1,
			},
			[152108] = { -- катаклизм
				spellID = 152108,
				class = "WARLOCK",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				-- cast_time = 6,
				quality = 1,
			},
			[111397] = { -- кровавый ужас
				spellID = 111397,
				class = "WARLOCK",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- trigger = {},
				-- cast_time = 6,
				quality = 1,
			},
			[137587] = { -- Коварство Кил'джедена
				spellID = 137587,
				class = "WARLOCK",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- trigger = {},
				cast_time = 8,
				quality = 1,
			},
		}
		local list_dk = {
			[115989] = { -- нечестивая порча
				spellID = 115989,
				class = "DEATHKNIGHT",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
			[49039] = { -- перерождение
				spellID = 49039,
				class = "DEATHKNIGHT",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
			[96268] = { -- поступь смерти
				spellID = 96268,
				class = "DEATHKNIGHT",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[48743] = { -- смертельный союз
				spellID = 48743,
				class = "DEATHKNIGHT",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				-- cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[51052] = { -- зона антимагии
				turn_on = true,
				spellID = 51052,
				class = "DEATHKNIGHT",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 1,
				cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[108194] = { -- афиксия
				spellID = 108194,
				class = "DEATHKNIGHT",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				cast_time = 5,
				-- trigger = {},
				quality = 1,
			},
			[114556] = { -- очищение
				spellID = 114556,
				class = "DEATHKNIGHT",
				CD = 180,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 3,
				trigger = { 116888, 123981 },
				quality = 1,
			},
			[108199] = { -- хватка Кровожада
				spellID = 108199,
				class = "DEATHKNIGHT",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				--cast_time = 3,
				--trigger = {  },
				quality = 1,
			},
			[108200] = { -- беспощадность зимы
				spellID = 108200,
				class = "DEATHKNIGHT",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 8,
				--trigger = {  },
				quality = 1,
			},
			[108201] = { -- оскверненная земля
				spellID = 108201,
				class = "DEATHKNIGHT",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 10,
				--trigger = {  },
				quality = 1,
			},
			[152279] = { -- Дыхание Синдрагосы
				spellID = 152279,
				class = "DEATHKNIGHT",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
			[152280] = { -- Осквернение
				spellID = 152280,
				class = "DEATHKNIGHT",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 1,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
		}
		local list_monk = { --?????????
			[116841] = { -- тигриное рвение
				spellID = 116841,
				class = "MONK",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[119392] = { -- несущийся бык
				spellID = 119392,
				class = "MONK",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- cast_time = 100,
				-- trigger = {},
				quality = 1,
			},
			[122278] = { -- смягчение удара
				spellID = 122278,
				class = "MONK",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				-- cast_time = 100,
				-- trigger = {},
				quality = 1,
			},
			[119381] = { -- круговой удар ногой
				spellID = 119381,
				class = "MONK",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- cast_time = 100,
				-- trigger = {},
				quality = 1,
			},
			[122783] = { -- расыление магии
				spellID = 122783,
				class = "MONK",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[123904] = { -- призыв сюзня, белого тигра ??????????
				spellID = 123904,
				class = "MONK",
				CD = 180,
				succ = "SPELL_CAST_SUCCESS",
				type = 6,
				cast_time = 45,
				-- trigger = {},
				quality = 1,
			},
			[116844] = { -- круг мира (сало на 3 при касте, дизарм + нельзя автоатаки)
				spellID = 116844,
				class = "MONK",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				cast_time = 4,
				-- trigger = {},
				quality = 1,
			},
			[123986] = { -- Выброс ци
				spellID = 123986,
				class = "MONK",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 1,
				-- trigger = {},
				quality = 1,
			},
			[152173] = { -- Безмятежность
				spellID = 152173,
				class = "MONK",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
		}
		local list_hunter = { --???????
			[109304] = { -- живость
				spellID = 109304,
				class = "HUNTER",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[131894] = { -- стая воронов
				spellID = 131894,
				class = "HUNTER",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				cast_time = 30,
				-- trigger = {},
				quality = 1,
			},
			[19386] = { -- укус виверны
				spellID = 19386,
				class = "HUNTER",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[120679] = { -- ужасный зверь
				spellID = 120679,
				class = "HUNTER",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				cast_time = 15,
				trigger = { 122802 },
				quality = 1,
			},
			[121818] = { -- звериный натиск
				spellID = 121818,
				class = "HUNTER",
				CD = 300,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				cast_time = 20,
				-- trigger = {},
				quality = 1,
			},
			[109248] = { -- связующий выстрел
				spellID = 109248,
				class = "HUNTER",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[19577] = { -- устрашение
				spellID = 19577,
				class = "HUNTER",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[109259] = { -- мощный выстрел ??????????
				spellID = 109259,
				class = "HUNTER",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[120360] = { -- шквал ??????????????
				spellID = 120360,
				class = "HUNTER",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
		}
		local list_shaman = {
			[30884] = { -- страж природы +
				spellID = 30884,
				class = "SHAMAN",
				CD = 30,
				succ = "SPELL_AURA_APPLIED",
				type = 8,
				cast_time = 10,
				trigger = { 31616 },
				quality = 1,
			},
			[108270] = { -- тотем каменной преграды +
				spellID = 108270,
				class = "SHAMAN",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[108271] = { -- астральный сдвиг
				spellID = 108271,
				class = "SHAMAN",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[51485] = { -- тотем хватки земли +
				spellID = 51485,
				class = "SHAMAN",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				cast_time = 20,
				-- trigger = {},
				quality = 1,
			},
			[108273] = { -- тотем ветроступа +
				spellID = 108273,
				class = "SHAMAN",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 6,
				-- trigger = {},
				quality = 1,
			},
			[108285] = { -- зов стихий +
				spellID = 108285,
				class = "SHAMAN",
				CD = 180,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[16166] = { -- покорение стихий +
				spellID = 16166,
				class = "SHAMAN",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				cast_time = 20,
				-- trigger = {},
				quality = 1,
			},
			[16188] = { -- стремительность предков +
				spellID = 16188,
				class = "SHAMAN",
				CD = 60,
				succ = "SPELL_AURA_REMOVED",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[108281] = { -- наставления предков +
				spellID = 108281,
				class = "SHAMAN",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
			[152255] = { -- Жидкая магма
				spellID = 152255,
				class = "SHAMAN",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
			[152256] = { -- Тотем элементаля бури
				spellID = 152256,
				class = "SHAMAN",
				CD = 300,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 60,
				-- trigger = {},
				quality = 1,
			},
		}
		local list_mage = {
			[113724] = { -- кольцо мороза
				spellID = 113724,
				class = "MAGE",
				CD = 45,
				succ = "SPELL_SUMMON",
				type = 9,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
			[108839] = { -- плавучая льдина
				spellID = 108839,
				class = "MAGE",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[108843] = { -- молниеносность
				spellID = 108843,
				class = "MAGE",
				CD = 25,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[111264] = { -- ледяной заслон
				spellID = 111264,
				class = "MAGE",
				CD = 20,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[11426] = { -- леденая преграда
				spellID = 11426,
				class = "MAGE",
				CD = 25,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[102051] = { -- леденая хватка
				spellID = 102051,
				class = "MAGE",
				CD = 20,
				succ = "SPELL_AURA_APPLIED",
				type = 9,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[110959] = { -- великая неведимость
				spellID = 110959,
				class = "MAGE",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 23,
				trigger = { 110960, 66 },
				quality = 1,
			},
			[86949] = { -- прижигание
				spellID = 86949,
				class = "MAGE",
				CD = 120,
				succ = "SPELL_AURA_APPLIED",
				type = 4,
				-- cast_time = 3,
				trigger = { 87024, 87023 },
				quality = 1,
			},
			[157913] = { -- Пропадание
				spellID = 157913,
				class = "MAGE",
				CD = 45,
				succ = "SPELL_AURA_APPLIED",
				type = 4,
				cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[108978] = { -- Путешествие во времени
				spellID = 108978,
				class = "MAGE",
				CD = 90,
				succ = {"SPELL_CAST_SUCCESS", "SPELL_AURA_REMOVED", },
				type = 4,
				-- cast_time = 10,
				trigger = { 110909 },
				quality = 1,
			},
			[11958] = { -- холодная хватка
				spellID = 11958,
				class = "MAGE",
				CD = 180,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[55342] = { -- Зеркальное изображение
				spellID = 55342,
				class = "MAGE",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 40,
				-- trigger = {},
				quality = 1,
			},
			[152087] = { -- Радужный кристалл
				spellID = 152087,
				class = "MAGE",
				CD = 90,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 12,
				-- trigger = {},
				quality = 1,
			},
		}
		local list_rogue = {
			[74001] = { -- боевая готовность
				spellID = 74001,
				class = "ROGUE",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 20,
				-- trigger = {},
				quality = 1,
			},
			[31230] = { -- обман смерти
				spellID = 31230,
				class = "ROGUE",
				CD = 90,
				succ = "SPELL_AURA_APPLIED",
				type = 4,
				-- cast_time = 3,
				trigger = { 45182 },
				quality = 1,
			},
			[36554] = { -- шаг сквозь тень
				spellID = 36554,
				class = "ROGUE",
				CD = 20,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[152151] = { -- теневое отражение
				spellID = 152151,
				class = "ROGUE",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 16,
				-- trigger = {},
				quality = 1,
			},
		}
		local list_warrior = {
			[103826] = { -- неудержимость +
				spellID = 100,
				class = "WARRIOR",
				CD = 12,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[55694] = { -- безудержное восстановление +
				spellID = 55694,
				class = "WARRIOR",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[103840] = { -- верная победа +
				spellID = 103840,
				class = "WARRIOR",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[46924] = { -- вихрь клинков +
				spellID = 46924,
				class = "WARRIOR",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = { 50622 },
				quality = 1,
			},
			[46968] = { -- ударная волна +
				spellID = 46968,
				class = "WARRIOR",
				CD = 20,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				cast_time = 4,
				-- trigger = {},
				quality = 1,
			},
			[118000] = { -- рев дракона +
				spellID = 118000,
				class = "WARRIOR",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[114028] = { -- Массовое отражение заклинания +
				spellID = 114028,
				class = "WARRIOR",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				-- cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[114029] = { -- охрана
				spellID = 114029,
				class = "WARRIOR",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 5,
				cast_time = 6,
				trigger = { 3411 },
				quality = 1,
			},
			[114030] = { -- бдительность
				turn_on = true,
				spellID = 114030,
				class = "WARRIOR",
				CD = 120,
				succ = "SPELL_CAST_SUCCESS",
				type = 5,
				cast_time = 12,
				-- trigger = {},
				quality = 1,
			},
			[107574] = { -- аватара
				spellID = 107574,
				class = "WARRIOR",
				CD = 180,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				cast_time = 24,
				-- trigger = {},
				quality = 1,
			},
			[12292] = { -- кровавая бойня
				spellID = 12292,
				class = "WARRIOR",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 10,
				cast_time = 12,
				-- trigger = {},
				quality = 1,
			},
			[107570] = { -- удар громовержца
				spellID = 107570,
				class = "WARRIOR",
				CD = 30,
				succ = "SPELL_CAST_SUCCESS",
				type = 9,
				cast_time = 3,
				-- trigger = {},
				quality = 1,
			},
			[152277] = { -- опустошитель
				turn_on = true,
				spellID = 152277,
				class = "WARRIOR",
				CD = 60,
				succ = "SPELL_CAST_SUCCESS",
				type = 4,
				cast_time = 10,
				-- trigger = {},
				quality = 1,
			},
			[176289] = { -- стенолом
				spellID = 176289,
				class = "WARRIOR",
				CD = 45,
				succ = "SPELL_CAST_SUCCESS",
				type = 8,
				cast_time = 1,
				-- trigger = {},
				quality = 1,
			},
		}

		local bad_spells = 0;
		local function formArray(arr)
		    for k, i in next, arr do
			    if (select(1, GetSpellInfo(i.spellID)) ~= nil) then
				    i.talent = true
					list_talents[k] = i
				else
					bad_spells = bad_spells + 1
					HCoold:Printf("   bad spell id = %d", i.spellID)
				end
			end
		end

		-- for i = 55694, 55794, 1 do if (GetSpellLink(i) ~= nil) then HCoold:Printf("Spell %d %s", i, GetSpellLink(i)) end end

		formArray(list_paladin)
		formArray(list_druid)
		formArray(list_priest)
		formArray(list_warlock)
		formArray(list_dk)
		formArray(list_monk)
		formArray(list_hunter)
		formArray(list_shaman)
		formArray(list_mage)
		formArray(list_rogue)
		formArray(list_warrior)

		HCoold:Printf("Found %d old spells in talents", bad_spells)
	end

	do -- generate spec_spells
        table.insert(spec_spells, { -- WARRIOR 1 Arms 2 Fury 3 Protection
            class = "WARRIOR",
            specs = {
                [1] = { -- Arms
                    { id = 12294, }, -- Mortal Strike http://www.wowhead.com/spell=12294
                    { id = 227847, }, -- Bladestorm http://www.wowhead.com/spell=227847
                    { id = 845, }, -- Cleave http://www.wowhead.com/spell=845
                    { id = 167105, }, -- Colossus Smash http://www.wowhead.com/spell=167105
                    { id = 118038, }, -- Die by the Sword http://www.wowhead.com/spell=118038
                    { id = 163201, }, -- Execute http://www.wowhead.com/spell=163201
                    { id = 1464, }, -- Slam http://www.wowhead.com/spell=1464
                    { id = 1680, }, -- Whirlwind http://www.wowhead.com/spell=1680
                    { id = 1715, }, -- Hamstring http://www.wowhead.com/spell=1715
                },
                [2] = { -- Fury
                    { id = 12323, }, -- Piercing Howl http://www.wowhead.com/spell=12323
                    { id = 184367, }, -- Rampage http://www.wowhead.com/spell=184367
                    { id = 184364, }, -- Enraged Regeneration http://www.wowhead.com/spell=184364
                    { id = 5308, }, -- Execute http://www.wowhead.com/spell=5308
                    { id = 85288, }, -- Raging Blow http://www.wowhead.com/spell=85288
                    { id = 23881, }, -- Bloodthirst http://www.wowhead.com/spell=23881
                    { id = 100130, }, -- Furious Slash http://www.wowhead.com/spell=100130
                    { id = 190411, }, -- Whirlwind http://www.wowhead.com/spell=190411
                },
                [3] = { -- Protection
                    { id = 6343, }, -- Thunder Clap http://www.wowhead.com/spell=6343
                    { id = 6572, }, -- Revenge http://www.wowhead.com/spell=6572
                    { id = 2565, }, -- Shield Block http://www.wowhead.com/spell=2565
                    { id = 12975, }, -- Last Stand http://www.wowhead.com/spell=12975
                    { id = 871, }, -- Shield Wall http://www.wowhead.com/spell=871
                    { id = 1160, }, -- Demoralizing Shout http://www.wowhead.com/spell=1160
                    { id = 23920, }, -- Spell Reflection http://www.wowhead.com/spell=23920
                    { id = 23922, }, -- Shield Slam http://www.wowhead.com/spell=23922
                    { id = 198304, }, -- Intercept http://www.wowhead.com/spell=198304
                    { id = 204488, }, -- Focused Rage http://www.wowhead.com/spell=204488
                    { id = 20243, }, -- Devastate http://www.wowhead.com/spell=20243
                    { id = 157494, }, -- Improved Defensive Stance http://www.wowhead.com/spell=157494
                    { id = 157497, }, -- Improved Block http://www.wowhead.com/spell=157497
                    { id = 190456, }, -- Ignore Pain http://www.wowhead.com/spell=190456
                },
            },
        })
        table.insert(spec_spells, { -- PALADIN 1 Holy 2 Protection 3 Retribution
            class = "PALADIN",
            specs = {
                [1] = { -- Holy
                    { id = 53563, }, -- Beacon of Light http://www.wowhead.com/spell=53563
                    { id = 82326, }, -- Holy Light http://www.wowhead.com/spell=82326
                    { id = 4987, }, -- Cleanse http://www.wowhead.com/spell=4987
                    { id = 31821, }, -- Aura Mastery http://www.wowhead.com/spell=31821
                    { id = 212056, }, -- Absolution http://www.wowhead.com/spell=212056
                    { id = 31842, }, -- Avenging Wrath http://www.wowhead.com/spell=31842
                    { id = 85222, }, -- Light of Dawn http://www.wowhead.com/spell=85222
                    { id = 183998, }, -- Light of the Martyr http://www.wowhead.com/spell=183998
                    { id = 20473, }, -- Holy Shock http://www.wowhead.com/spell=20473
                },
                [2] = { -- Protection
                    { id = 190784, }, -- Divine Steed http://www.wowhead.com/spell=190784
                    { id = 53595, }, -- Hammer of the Righteous http://www.wowhead.com/spell=53595
                    { id = 53600, }, -- Shield of the Righteous http://www.wowhead.com/spell=53600
                    { id = 86659, }, -- Guardian of Ancient Kings http://www.wowhead.com/spell=86659
                    { id = 31850, }, -- Ardent Defender http://www.wowhead.com/spell=31850
                    { id = 31935, }, -- Avenger's Shield http://www.wowhead.com/spell=31935
                    { id = 184092, }, -- Light of the Protector http://www.wowhead.com/spell=184092
                },
                [3] = { -- Retribution
                    { id = 53385, }, -- Divine Storm http://www.wowhead.com/spell=53385
                    { id = 184575, }, -- Blade of Justice http://www.wowhead.com/spell=184575
                    { id = 184662, }, -- Shield of Vengeance http://www.wowhead.com/spell=184662
                    { id = 203528, }, -- Greater Blessing of Might http://www.wowhead.com/spell=203528
                    { id = 203539, }, -- Greater Blessing of Wisdom http://www.wowhead.com/spell=203539
                    { id = 203538, }, -- Greater Blessing of Kings http://www.wowhead.com/spell=203538
                    { id = 183218, }, -- Hand of Hindrance http://www.wowhead.com/spell=183218
                    { id = 85256, }, -- Templar's Verdict http://www.wowhead.com/spell=85256
                },
            },
        })
        table.insert(spec_spells, { -- HUNTER 1 Beast Mastery 2 Marksmanship 3 Survival
            class = "HUNTER",
            specs = {
                [1] = { -- Beast Mastery
                    { id = 193455, }, -- Cobra Shot http://www.wowhead.com/spell=193455
                    { id = 193530, }, -- Aspect of the Wild http://www.wowhead.com/spell=193530
                    { id = 19574, }, -- Bestial Wrath http://www.wowhead.com/spell=19574
                    { id = 34026, }, -- Kill Command http://www.wowhead.com/spell=34026
                    { id = 120679, }, -- Dire Beast http://www.wowhead.com/spell=120679
                },
                [2] = { -- Marksmanship
                    { id = 186387, }, -- Bursting Shot http://www.wowhead.com/spell=186387
                    { id = 157726, }, -- Improved Focus http://www.wowhead.com/spell=157726
                    { id = 19434, }, -- Aimed Shot http://www.wowhead.com/spell=19434
                    { id = 193526, }, -- Trueshot http://www.wowhead.com/spell=193526
                    { id = 185358, }, -- Arcane Shot http://www.wowhead.com/spell=185358
                    { id = 185901, }, -- Marked Shot http://www.wowhead.com/spell=185901
                    { id = 194291, }, -- Exhilaration http://www.wowhead.com/spell=194291
                },
                [3] = { -- Survival
                    { id = 202800, }, -- Flanking Strike http://www.wowhead.com/spell=202800
                    { id = 190925, }, -- Harpoon http://www.wowhead.com/spell=190925
                    { id = 190928, }, -- Mongoose Bite http://www.wowhead.com/spell=190928
                    { id = 193265, }, -- Hatchet Toss http://www.wowhead.com/spell=193265
                    { id = 191433, }, -- Explosive Trap http://www.wowhead.com/spell=191433
                    { id = 195645, }, -- Wing Clip http://www.wowhead.com/spell=195645
                    { id = 187650, }, -- Freezing Trap http://www.wowhead.com/spell=187650
                    { id = 187698, }, -- Tar Trap http://www.wowhead.com/spell=187698
                    { id = 187707, }, -- Muzzle http://www.wowhead.com/spell=187707
                    { id = 187708, }, -- Carve http://www.wowhead.com/spell=187708
                    { id = 185855, }, -- Lacerate http://www.wowhead.com/spell=185855
                    { id = 186270, }, -- Raptor Strike http://www.wowhead.com/spell=186270
                    { id = 186289, }, -- Aspect of the Eagle http://www.wowhead.com/spell=186289
                },
            },
        })
        table.insert(spec_spells, { -- ROGUE 1 Assassination 2 Outlaw 3 Subtlety
            class = "ROGUE",
            specs = {
                [1] = { -- Assassination
                    { id = 8679, }, -- Wound Poison http://www.wowhead.com/spell=8679
                    { id = 51723, }, -- Fan of Knives http://www.wowhead.com/spell=51723
                    { id = 703, }, -- Garrote http://www.wowhead.com/spell=703
                    { id = 2823, }, -- Deadly Poison http://www.wowhead.com/spell=2823
                    { id = 185565, }, -- Poisoned Knife http://www.wowhead.com/spell=185565
                    { id = 79140, }, -- Vendetta http://www.wowhead.com/spell=79140
                    { id = 1329, }, -- Mutilate http://www.wowhead.com/spell=1329
                    { id = 3408, }, -- Crippling Poison http://www.wowhead.com/spell=3408
                    { id = 32645, }, -- Envenom http://www.wowhead.com/spell=32645
                    { id = 1943, }, -- Rupture http://www.wowhead.com/spell=1943
                },
                [2] = { -- Outlaw
                    { id = 2098, }, -- Run Through http://www.wowhead.com/spell=2098
                    { id = 8676, }, -- Ambush http://www.wowhead.com/spell=8676
                    { id = 193315, }, -- Saber Slash http://www.wowhead.com/spell=193315
                    { id = 193316, }, -- Roll the Bones http://www.wowhead.com/spell=193316
                    { id = 199736, }, -- Find Treasure http://www.wowhead.com/spell=199736
                    { id = 199740, }, -- Bribe http://www.wowhead.com/spell=199740
                    { id = 199754, }, -- Riposte http://www.wowhead.com/spell=199754
                    { id = 199804, }, -- Between the Eyes http://www.wowhead.com/spell=199804
                    { id = 185763, }, -- Pistol Shot http://www.wowhead.com/spell=185763
                    { id = 13750, }, -- Adrenaline Rush http://www.wowhead.com/spell=13750
                    { id = 13877, }, -- Blade Flurry http://www.wowhead.com/spell=13877
                    { id = 1776, }, -- Gouge http://www.wowhead.com/spell=1776
                },
                [3] = { -- Subtlety
                    { id = 157704, }, -- Enhanced Stealth http://www.wowhead.com/spell=157704
                    { id = 53, }, -- Backstab http://www.wowhead.com/spell=53
                    { id = 196819, }, -- Eviscerate http://www.wowhead.com/spell=196819
                    { id = 121471, }, -- Shadow Blades http://www.wowhead.com/spell=121471
                    { id = 195452, }, -- Nightblade http://www.wowhead.com/spell=195452
                    { id = 185313, }, -- Shadow Dance http://www.wowhead.com/spell=185313
                    { id = 185438, }, -- Shadowstrike http://www.wowhead.com/spell=185438
                    { id = 197835, }, -- Shuriken Storm http://www.wowhead.com/spell=197835
                    { id = 212283, }, -- Symbols of Death http://www.wowhead.com/spell=212283
                    { id = 114014, }, -- Shuriken Toss http://www.wowhead.com/spell=114014
                    { id = 157666, }, -- Enhanced Vanish http://www.wowhead.com/spell=157666
                    { id = 157671, }, -- Empowered Fan of Knives http://www.wowhead.com/spell=157671
                },
            },
        })
        table.insert(spec_spells, { -- PRIEST 1 Discipline 2 Holy 3 Shadow
            class = "PRIEST",
            specs = {
                [1] = { -- Discipline
                    { id = 200829, }, -- Plea http://www.wowhead.com/spell=200829
                    { id = 47536, }, -- Rapture http://www.wowhead.com/spell=47536
                    { id = 47540, }, -- Penance http://www.wowhead.com/spell=47540
                    { id = 33206, }, -- Pain Suppression http://www.wowhead.com/spell=33206
                    { id = 62618, }, -- Power Word: Barrier http://www.wowhead.com/spell=62618
                    { id = 194509, }, -- Power Word: Radiance http://www.wowhead.com/spell=194509
                },
                [2] = { -- Holy
                    { id = 2050, }, -- Holy Word: Serenity http://www.wowhead.com/spell=2050
                    { id = 2060, }, -- Heal http://www.wowhead.com/spell=2060
                    { id = 2061, }, -- Flash Heal http://www.wowhead.com/spell=2061
                    { id = 34861, }, -- Holy Word: Sanctify http://www.wowhead.com/spell=34861
                    { id = 139, }, -- Renew http://www.wowhead.com/spell=139
                    { id = 33076, }, -- Prayer of Mending http://www.wowhead.com/spell=33076
                    { id = 88625, }, -- Holy Word: Chastise http://www.wowhead.com/spell=88625
                    { id = 14914, }, -- Holy Fire http://www.wowhead.com/spell=14914
                    { id = 596, }, -- Prayer of Healing http://www.wowhead.com/spell=596
                    { id = 47788, }, -- Guardian Spirit http://www.wowhead.com/spell=47788
                    { id = 132157, }, -- Holy Nova http://www.wowhead.com/spell=132157
                    { id = 64843, }, -- Divine Hymn http://www.wowhead.com/spell=64843
                },
                [3] = { -- Shadow
                    { id = 34914, }, -- Vampiric Touch http://www.wowhead.com/spell=34914
                    { id = 47585, }, -- Dispersion http://www.wowhead.com/spell=47585
                    { id = 213634, }, -- Purify Disease http://www.wowhead.com/spell=213634
                    { id = 228260, }, -- Void Eruption http://www.wowhead.com/spell=228260
                    { id = 48045, }, -- Mind Sear http://www.wowhead.com/spell=48045
                    { id = 15286, }, -- Vampiric Embrace http://www.wowhead.com/spell=15286
                    { id = 15407, }, -- Mind Flay http://www.wowhead.com/spell=15407
                    { id = 15487, }, -- Silence http://www.wowhead.com/spell=15487
                    { id = 32379, }, -- Shadow Word: Death http://www.wowhead.com/spell=32379
                    { id = 194248, }, -- Insanity Visual Controller http://www.wowhead.com/spell=194248
                    { id = 8092, }, -- Mind Blast http://www.wowhead.com/spell=8092
                },
            },
        })
        table.insert(spec_spells, { -- DEATHKNIGHT 1 Blood 2 Frost 3 Unholy
            class = "DEATHKNIGHT",
            specs = {
                [1] = { -- Blood
                    { id = 206930, }, -- Heart Strike http://www.wowhead.com/spell=206930
                    { id = 221562, }, -- Asphyxiate http://www.wowhead.com/spell=221562
                    { id = 195182, }, -- Marrowrend http://www.wowhead.com/spell=195182
                    { id = 195292, }, -- Death's Caress http://www.wowhead.com/spell=195292
                    { id = 195740, }, -- Blood Plague http://www.wowhead.com/spell=195740
                    { id = 50842, }, -- Blood Boil http://www.wowhead.com/spell=50842
                    { id = 108199, }, -- Gorefiend's Grasp http://www.wowhead.com/spell=108199
                    { id = 49028, }, -- Dancing Rune Weapon http://www.wowhead.com/spell=49028
                    { id = 55233, }, -- Vampiric Blood http://www.wowhead.com/spell=55233
                },
                [2] = { -- Frost
                    { id = 49184, }, -- Howling Blast http://www.wowhead.com/spell=49184
                    { id = 51271, }, -- Pillar of Frost http://www.wowhead.com/spell=51271
                    { id = 196770, }, -- Remorseless Winter http://www.wowhead.com/spell=196770
                    { id = 47568, }, -- Empower Rune Weapon http://www.wowhead.com/spell=47568
                    { id = 49020, }, -- Obliterate http://www.wowhead.com/spell=49020
                    { id = 49143, }, -- Frost Strike http://www.wowhead.com/spell=49143
                },
                [3] = { -- Unholy
                    { id = 49206, }, -- Summon Gargoyle http://www.wowhead.com/spell=49206
                    { id = 63560, }, -- Dark Transformation http://www.wowhead.com/spell=63560
                    { id = 47541, }, -- Death Coil http://www.wowhead.com/spell=47541
                    { id = 46584, }, -- Raise Dead http://www.wowhead.com/spell=46584
                    { id = 42650, }, -- Army of the Dead http://www.wowhead.com/spell=42650
                    { id = 77575, }, -- Outbreak http://www.wowhead.com/spell=77575
                    { id = 55090, }, -- Scourge Strike http://www.wowhead.com/spell=55090
                    { id = 85948, }, -- Festering Strike http://www.wowhead.com/spell=85948
                },
            },
        })
        table.insert(spec_spells, { -- SHAMAN 1 Elemental 2 Enhancement 3 Restoration
            class = "SHAMAN",
            specs = {
                [1] = { -- Elemental
                    { id = 188443, }, -- Chain Lightning http://www.wowhead.com/spell=188443
                    { id = 196840, }, -- Frost Shock http://www.wowhead.com/spell=196840
                    { id = 51490, }, -- Thunderstorm http://www.wowhead.com/spell=51490
                    { id = 61882, }, -- Earthquake Totem http://www.wowhead.com/spell=61882
                    { id = 198067, }, -- Fire Elemental http://www.wowhead.com/spell=198067
                    { id = 198103, }, -- Earth Elemental http://www.wowhead.com/spell=198103
                    { id = 188196, }, -- Lightning Bolt http://www.wowhead.com/spell=188196
                    { id = 8042, }, -- Earth Shock http://www.wowhead.com/spell=8042
                    { id = 188389, }, -- Flame Shock http://www.wowhead.com/spell=188389
                },
                [2] = { -- Enhancement
                    { id = 196834, }, -- Frostbrand http://www.wowhead.com/spell=196834
                    { id = 51533, }, -- Feral Spirit http://www.wowhead.com/spell=51533
                    { id = 60103, }, -- Lava Lash http://www.wowhead.com/spell=60103
                    { id = 17364, }, -- Stormstrike http://www.wowhead.com/spell=17364
                    { id = 195771, }, -- Maelstrom Controller Decreasing http://www.wowhead.com/spell=195771
                    { id = 193786, }, -- Rockbiter http://www.wowhead.com/spell=193786
                    { id = 193796, }, -- Flametongue http://www.wowhead.com/spell=193796
                    { id = 187837, }, -- Lightning Bolt http://www.wowhead.com/spell=187837
                    { id = 187874, }, -- Crash Lightning http://www.wowhead.com/spell=187874
                    { id = 58875, }, -- Spirit Walk http://www.wowhead.com/spell=58875
                    { id = 188070, }, -- Healing Surge http://www.wowhead.com/spell=188070
                    { id = 16282, }, -- Flurry http://www.wowhead.com/spell=16282
                },
                [3] = { -- Restoration
                    { id = 73920, }, -- Healing Rain http://www.wowhead.com/spell=73920
                    { id = 403, }, -- Lightning Bolt http://www.wowhead.com/spell=403
                    { id = 188838, }, -- Flame Shock http://www.wowhead.com/spell=188838
                    { id = 421, }, -- Chain Lightning http://www.wowhead.com/spell=421
                    { id = 1064, }, -- Chain Heal http://www.wowhead.com/spell=1064
                    { id = 212048, }, -- Ancestral Vision http://www.wowhead.com/spell=212048
                    { id = 5394, }, -- Healing Stream Totem http://www.wowhead.com/spell=5394
                    { id = 77130, }, -- Purify Spirit http://www.wowhead.com/spell=77130
                    { id = 79206, }, -- Spiritwalker's Grace http://www.wowhead.com/spell=79206
                    { id = 77472, }, -- Healing Wave http://www.wowhead.com/spell=77472
                    { id = 98008, }, -- Spirit Link Totem http://www.wowhead.com/spell=98008
                    { id = 108280, }, -- Healing Tide Totem http://www.wowhead.com/spell=108280
                    { id = 61295, }, -- Riptide http://www.wowhead.com/spell=61295
                },
            },
        })
        table.insert(spec_spells, { -- MAGE 1 Arcane 2 Fire 3 Frost
            class = "MAGE",
            specs = {
                [1] = { -- Arcane
                    { id = 110959, }, -- Greater Invisibility http://www.wowhead.com/spell=110959
                    { id = 31589, }, -- Slow http://www.wowhead.com/spell=31589
                    { id = 5143, }, -- Arcane Missiles http://www.wowhead.com/spell=5143
                    { id = 195676, }, -- Displacement http://www.wowhead.com/spell=195676
                    { id = 44425, }, -- Arcane Barrage http://www.wowhead.com/spell=44425
                    { id = 1449, }, -- Arcane Explosion http://www.wowhead.com/spell=1449
                    { id = 30451, }, -- Arcane Blast http://www.wowhead.com/spell=30451
                    { id = 12042, }, -- Arcane Power http://www.wowhead.com/spell=12042
                    { id = 12051, }, -- Evocation http://www.wowhead.com/spell=12051
                    { id = 114664, }, -- Arcane Charge http://www.wowhead.com/spell=114664
                },
                [2] = { -- Fire
                    { id = 2120, }, -- Flamestrike http://www.wowhead.com/spell=2120
                    { id = 133, }, -- Fireball http://www.wowhead.com/spell=133
                    { id = 108853, }, -- Fire Blast http://www.wowhead.com/spell=108853
                    { id = 2948, }, -- Scorch http://www.wowhead.com/spell=2948
                    { id = 31661, }, -- Dragon's Breath http://www.wowhead.com/spell=31661
                    { id = 11366, }, -- Pyroblast http://www.wowhead.com/spell=11366
                    { id = 190319, }, -- Combustion http://www.wowhead.com/spell=190319
                },
                [3] = { -- Frost
                    { id = 116, }, -- Frostbolt http://www.wowhead.com/spell=116
                    { id = 120, }, -- Cone of Cold http://www.wowhead.com/spell=120
                    { id = 12472, }, -- Icy Veins http://www.wowhead.com/spell=12472
                    { id = 84714, }, -- Frozen Orb http://www.wowhead.com/spell=84714
                    { id = 31687, }, -- Summon Water Elemental http://www.wowhead.com/spell=31687
                    { id = 44614, }, -- Flurry http://www.wowhead.com/spell=44614
                    { id = 30455, }, -- Ice Lance http://www.wowhead.com/spell=30455
                    { id = 190356, }, -- Blizzard http://www.wowhead.com/spell=190356
                },
            },
        })
        table.insert(spec_spells, { -- WARLOCK 1 Affliction 2 Demonology 3 Destruction
            class = "WARLOCK",
            specs = {
                [1] = { -- Affliction
                    { id = 172, }, -- Corruption http://www.wowhead.com/spell=172
                    { id = 27243, }, -- Seed of Corruption http://www.wowhead.com/spell=27243
                    { id = 980, }, -- Agony http://www.wowhead.com/spell=980
                    { id = 30108, }, -- Unstable Affliction http://www.wowhead.com/spell=30108
                },
                [2] = { -- Demonology
                    { id = 603, }, -- Doom http://www.wowhead.com/spell=603
                    { id = 686, }, -- Shadow Bolt http://www.wowhead.com/spell=686
                    { id = 105174, }, -- Hand of Gul'dan http://www.wowhead.com/spell=105174
                    { id = 193396, }, -- Demonic Empowerment http://www.wowhead.com/spell=193396
                    { id = 193440, }, -- Demonwrath http://www.wowhead.com/spell=193440
                    { id = 30146, }, -- Summon Felguard http://www.wowhead.com/spell=30146
                    { id = 104316, }, -- Call Dreadstalkers http://www.wowhead.com/spell=104316
                },
                [3] = { -- Destruction
                    { id = 116858, }, -- Chaos Bolt http://www.wowhead.com/spell=116858
                    { id = 348, }, -- Immolate http://www.wowhead.com/spell=348
                    { id = 80240, }, -- Havoc http://www.wowhead.com/spell=80240
                    { id = 29722, }, -- Incinerate http://www.wowhead.com/spell=29722
                    { id = 17962, }, -- Conflagrate http://www.wowhead.com/spell=17962
                    { id = 5740, }, -- Rain of Fire http://www.wowhead.com/spell=5740
                },
            },
        })
        table.insert(spec_spells, { -- MONK 1 Brewmaster 2 Mistweaver 3 Windwalker
            class = "MONK",
            specs = {
                [1] = { -- Brewmaster
                    { id = 115072, }, -- Expel Harm http://www.wowhead.com/spell=115072
                    { id = 121253, }, -- Keg Smash http://www.wowhead.com/spell=121253
                    { id = 115176, }, -- Zen Meditation http://www.wowhead.com/spell=115176
                    { id = 115181, }, -- Breath of Fire http://www.wowhead.com/spell=115181
                    { id = 115203, }, -- Fortifying Brew http://www.wowhead.com/spell=115203
                    { id = 115308, }, -- Ironskin Brew http://www.wowhead.com/spell=115308
                    { id = 205523, }, -- Blackout Strike http://www.wowhead.com/spell=205523
                    { id = 119582, }, -- Purifying Brew http://www.wowhead.com/spell=119582
                },
                [2] = { -- Mistweaver
                    { id = 116849, }, -- Life Cocoon http://www.wowhead.com/spell=116849
                    { id = 115151, }, -- Renewing Mist http://www.wowhead.com/spell=115151
                    { id = 115310, }, -- Revival http://www.wowhead.com/spell=115310
                    { id = 115450, }, -- Detox http://www.wowhead.com/spell=115450
                    { id = 212051, }, -- Reawaken http://www.wowhead.com/spell=212051
                    { id = 191837, }, -- Essence Font http://www.wowhead.com/spell=191837
                    { id = 124682, }, -- Enveloping Mist http://www.wowhead.com/spell=124682
                    { id = 116670, }, -- Vivify http://www.wowhead.com/spell=116670
                    { id = 116680, }, -- Thunder Focus Tea http://www.wowhead.com/spell=116680
                },
                [3] = { -- Windwalker
                    { id = 115080, }, -- Touch of Death http://www.wowhead.com/spell=115080
                    { id = 137639, }, -- Storm, Earth, and Fire http://www.wowhead.com/spell=137639
                    { id = 113656, }, -- Fists of Fury http://www.wowhead.com/spell=113656
                    { id = 101545, }, -- Flying Serpent Kick http://www.wowhead.com/spell=101545
                    { id = 116095, }, -- Disable http://www.wowhead.com/spell=116095
                    { id = 122470, }, -- Touch of Karma http://www.wowhead.com/spell=122470
                },
            },
        })
        table.insert(spec_spells, { -- DRUID 1 Balance 2 Feral 3 Guardian 4 Restoration
            class = "DRUID",
            specs = {
                [1] = { -- Balance
                    { id = 24858, }, -- Moonkin Form http://www.wowhead.com/spell=24858
                    { id = 190984, }, -- Solar Wrath http://www.wowhead.com/spell=190984
                    { id = 191034, }, -- Starfall http://www.wowhead.com/spell=191034
                    { id = 78675, }, -- Solar Beam http://www.wowhead.com/spell=78675
                    { id = 78674, }, -- Starsurge http://www.wowhead.com/spell=78674
                    { id = 197911, }, -- Astral Power http://www.wowhead.com/spell=197911
                    { id = 194153, }, -- Lunar Strike http://www.wowhead.com/spell=194153
                    { id = 194223, }, -- Celestial Alignment http://www.wowhead.com/spell=194223
                },
                [2] = { -- Feral
                    { id = 22568, }, -- Ferocious Bite http://www.wowhead.com/spell=22568
                    { id = 22570, }, -- Maim http://www.wowhead.com/spell=22570
                    { id = 106951, }, -- Berserk http://www.wowhead.com/spell=106951
                    { id = 1079, }, -- Rip http://www.wowhead.com/spell=1079
                    { id = 5217, }, -- Tiger's Fury http://www.wowhead.com/spell=5217
                    { id = 5221, }, -- Shred http://www.wowhead.com/spell=5221
                    { id = 228545, }, -- Cat Form http://www.wowhead.com/spell=228545
                    { id = 1822, }, -- Rake http://www.wowhead.com/spell=1822
                },
                [3] = { -- Guardian
                    { id = 99, }, -- Incapacitating Roar http://www.wowhead.com/spell=99
                    { id = 22842, }, -- Frenzied Regeneration http://www.wowhead.com/spell=22842
                    { id = 6807, }, -- Maul http://www.wowhead.com/spell=6807
                    { id = 33745, }, -- Lacerate http://www.wowhead.com/spell=33745
                    { id = 33917, }, -- Mangle http://www.wowhead.com/spell=33917
                    { id = 192083, }, -- Mark of Ursol http://www.wowhead.com/spell=192083
                    { id = 192081, }, -- Ironfur http://www.wowhead.com/spell=192081
                },
                [4] = { -- Restoration
                    { id = 18562, }, -- Swiftmend http://www.wowhead.com/spell=18562
                    { id = 88423, }, -- Nature's Cure http://www.wowhead.com/spell=88423
                    { id = 102793, }, -- Ursol's Vortex http://www.wowhead.com/spell=102793
                    { id = 740, }, -- Tranquility http://www.wowhead.com/spell=740
                    { id = 8936, }, -- Regrowth http://www.wowhead.com/spell=8936
                    { id = 774, }, -- Rejuvenation http://www.wowhead.com/spell=774
                    { id = 33763, }, -- Lifebloom http://www.wowhead.com/spell=33763
                    { id = 5176, }, -- Solar Wrath http://www.wowhead.com/spell=5176
                    { id = 212040, }, -- Revitalize http://www.wowhead.com/spell=212040
                    { id = 48438, }, -- Wild Growth http://www.wowhead.com/spell=48438
                    { id = 145205, }, -- Efflorescence http://www.wowhead.com/spell=145205
                    { id = 102342, }, -- Ironbark http://www.wowhead.com/spell=102342
                },
            },
        })
        table.insert(spec_spells, { -- DEMONHUNTER 1 Havoc 2 Vengeance
            class = "DEMONHUNTER",
            specs = {
                [1] = { -- Havoc
                },
                [2] = { -- Vengeance
                    { id = 178740, }, -- Immolation Aura http://www.wowhead.com/spell=178740
                    { id = 189110, }, -- Infernal Strike http://www.wowhead.com/spell=189110
                    { id = 207684, }, -- Sigil of Misery http://www.wowhead.com/spell=207684
                    { id = 185245, }, -- Torment http://www.wowhead.com/spell=185245
                    { id = 203720, }, -- Demon Spikes http://www.wowhead.com/spell=203720
                    { id = 203782, }, -- Shear http://www.wowhead.com/spell=203782
                    { id = 228477, }, -- Soul Cleave http://www.wowhead.com/spell=228477
                    { id = 218256, }, -- Empower Wards http://www.wowhead.com/spell=218256
                    { id = 204021, }, -- Fiery Brand http://www.wowhead.com/spell=204021
                    { id = 204157, }, -- Throw Glaive http://www.wowhead.com/spell=204157
                    { id = 202138, }, -- Sigil of Chains http://www.wowhead.com/spell=202138
                    { id = 202137, }, -- Sigil of Silence http://www.wowhead.com/spell=202137
                    { id = 187827, }, -- Metamorphosis http://www.wowhead.com/spell=187827
                    { id = 204596, }, -- Sigil of Flame http://www.wowhead.com/spell=204596
                },
            },
        })
	end

	do -- generate class_talents
		table.insert(class_talents,{ -- paladin
			class = "PALADIN",
			talents = {
				[1] = {
					[1] = 85499,
					[2] = nil,
					[3] = nil,
				},
				[2] = {
					[1] = 105593,
					[2] = 20066,
					[3] = 115750,
				},
				[3] = {
					[1] = nil,
					[2] = nil,
					[3] = 20925,
				},
				[4] = {
					[1] = 114039,
					[2] = nil,
					[3] = nil,
				},
				[5] = {
					[1] = 105809,
					[2] = nil,
					[3] = nil,
				},
				[6] = {
					[1] = 114165,
					[2] = 114158,
					[3] = 114157,
				},
				[7] = {
					[1] = nil,
					[2] = nil,
					[3] = 114157,
				},
			},
		})
		table.insert(class_talents,{ -- priest
			class = "PRIEST",
			talents = {
				[1] = {
					[1] = 19236,
					[2] = 112833,
					[3] = 108945,
				},
				[2] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[3] = {
					[1] = nil,
					[2] = 123040,
					[3] = nil,
				},
				[4] = {
					[1] = 108920,
					[2] = 8122,
					[3] = 605,
				},
				[5] = {
					[1] = nil,
					[2] = 10060,
					[3] = nil,
				},
				[6] = {
					[1] = 121135,
					[2] = 110744,
					[3] = 120517,
				},
				[7] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
			},
		})
		table.insert(class_talents,{ -- druid
			class = "DRUID",
			talents = {
				[1] = {
					[1] = nil,
					[2] = 102280,
					[3] = 102401,
				},
				[2] = {
					[1] = nil,
					[2] = 108238,
					[3] = 102351,
				},
				[3] = {
					[1] = nil,
					[2] = 102359,
					[3] = 132469,
				},
				[4] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[5] = {
					[1] = 99,
					[2] = 102793,
					[3] = 5211,
				},
				[6] = {
					[1] = 108292,
					[2] = nil,
					[3] = 124974,
				},
				[7] = {
					[1] = nil,
					[2] = nil,
					[3] = 155835,
				},
			},
		})
		table.insert(class_talents,{ -- warlock
			class = "WARLOCK",
			talents = {
				[1] = {
					[1] = 108359,
					[2] = nil,
					[3] = nil,
				},
				[2] = {
					[1] = 5484,
					[2] = 6789,
					[3] = 30283,
				},
				[3] = {
					[1] = nil,
					[2] = 108416,
					[3] = 110913,
				},
				[4] = {
					[1] = 111397,
					[2] = nil,
					[3] = 108482,
				},
				[5] = {
					[1] = nil,
					[2] = 108501,
					[3] = 108503,
				},
				[6] = {
					[1] = nil,
					[2] = 137587,
					[3] = 108508,
				},
				[7] = {
					[1] = nil,
					[2] = 152108,
					[3] = nil,
				},
			},
		})
		table.insert(class_talents,{ -- hunter
			class = "HUNTER",
			talents = {
				[1] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[2] = {
					[1] = 109248,
					[2] = 19386,
					[3] = 19577,
				},
				[3] = {
					[1] = 109304,
					[2] = nil,
					[3] = nil,
				},
				[4] = {
					[1] = nil,
					[2] = 120679,
					[3] = nil,
				},
				[5] = {
					[1] = 131894,
					[2] = nil,
					[3] = 121818,
				},
				[6] = {
					[1] = nil,
					[2] = 109259,
					[3] = 120360,
				},
				[7] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
			},
		})
		table.insert(class_talents,{ -- shaman
			class = "SHAMAN",
			talents = {
				[1] = {
					[1] = 30884,
					[2] = 108270,
					[3] = 108271,
				},
				[2] = {
					[1] = nil,
					[2] = 51485,
					[3] = 108273,
				},
				[3] = {
					[1] = 108285,
					[2] = nil,
					[3] = nil,
				},
				[4] = {
					[1] = 16166,
					[2] = 16188,
					[3] = nil,
				},
				[5] = {
					[1] = nil,
					[2] = 108281,
					[3] = nil,
				},
				[6] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[7] = {
					[1] = nil,
					[2] = 152256,
					[3] = 152255,
				},
			},
		})
		table.insert(class_talents,{ -- mage
			class = "MAGE",
			talents = {
				[1] = {
					[1] = 157913,
					[2] = 108843,
					[3] = 108839,
				},
				[2] = {
					[1] = 108978,
					[2] = nil,
					[3] = 11426,
				},
				[3] = {
					[1] = 113724,
					[2] = 111264,
					[3] = 102051,
				},
				[4] = {
					[1] = 110959,
					[2] = 86949,
					[3] = 11958,
				},
				[5] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[6] = {
					[1] = 55342,
					[2] = nil,
					[3] = nil,
				},
				[7] = {
					[1] = nil,
					[2] = 152087,
					[3] = nil,
				},
			},
		})
		table.insert(class_talents,{ -- rogue
			class = "ROGUE",
			talents = {
				[1] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[2] = {
					[1] = nil,
					[2] = nil,
					[3] = 74001,
				},
				[3] = {
					[1] = 31230,
					[2] = nil,
					[3] = nil,
				},
				[4] = {
					[1] = nil,
					[2] = 36554,
					[3] = nil,
				},
				[5] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[6] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[7] = {
					[1] = nil,
					[2] = 152151,
					[3] = nil,
				},
			},
		})
		table.insert(class_talents,{ -- dk
			class = "DEATHKNIGHT",
			talents = {
				[1] = {
					[1] = nil,
					[2] = nil,
					[3] = 115989,
				},
				[2] = {
					[1] = 49039,
					[2] = 51052,
					[3] = 114556,
				},
				[3] = {
					[1] = 96268,
					[2] = nil,
					[3] = 108194,
				},
				[4] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[5] = {
					[1] = 48743,
					[2] = nil,
					[3] = nil,
				},
				[6] = {
					[1] = 108199,
					[2] = 108200,
					[3] = 108201,
				},
				[7] = {
					[1] = nil,
					[2] = 152280,
					[3] = 152279,
				},
			},
		})
		table.insert(class_talents,{ -- monk
			class = "MONK",
			talents = {
				[1] = {
					[1] = nil,
					[2] = 116841,
					[3] = nil,
				},
				[2] = {
					[1] = nil,
					[2] = nil,
					[3] = 123986,
				},
				[3] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[4] = {
					[1] = 116844,
					[2] = 119392,
					[3] = 119381,
				},
				[5] = {
					[1] = nil,
					[2] = 122278,
					[3] = 122783,
				},
				[6] = {
					[1] = nil,
					[2] = 123904,
					[3] = nil,
				},
				[7] = {
					[1] = nil,
					[2] = nil,
					[3] = 152173,
				},
			},
		})
		table.insert(class_talents,{ -- warrior
			class = "WARRIOR",
			talents = {
				[1] = {
					[1] = 103826,
					[2] = nil,
					[3] = nil,
				},
				[2] = {
					[1] = 55694,
					[2] = nil,
					[3] = 103840,
				},
				[3] = {
					[1] = nil,
					[2] = nil,
					[3] = nil,
				},
				[4] = {
					[1] = 107570,
					[2] = 46968,
					[3] = 118000,
				},
				[5] = {
					[1] = 114028,
					[2] = 114029,
					[3] = 114030,
				},
				[6] = {
					[1] = 107574,
					[2] = 12292,
					[3] = 46924,
				},
				[7] = {
					[1] = nil,
					[2] = 152277,
					[3] = 176289,
				},
			},
		})
	end
end

function HCoold:MakeSpellList() -- in future - making self.spells that contains spells, that will be tracking by system by user configuration
	self.spells = {}
	for _,i in next, spells do
		local out = tostring(i.spellID)
		for _,j in next, i.specs do
			out = string.format("%s.%d",out,j)
		end
		if self.db.profile.trackSpells[out] == nil then self.db.profile.trackSpells[out] = true end
		if self.db.profile.trackSpells[out] then
			table.insert(self.spells,i)
		end
	end
end

function HCoold:GetSpecBySpell(spellID) -- return spec of class if it used this spell (check if spell is spec uniq)
	for _,i in next, spec_spells do
		for spec,j in next, i.specs do
			for _,p in next, j do
				if p.id == spellID then return spec end
			end
		end
	end
	return 0
end

local imbaSpell = { -- имба возрождение
				spellID = 20484,
				--succ = {"SPELL_RESURRECT", "SPELL_CAST_SUCCESS", "SPELL_CAST_START"}, -- SPELL_RESURRECT
				--specs = { 0, 1, 2, 3, 4 },
				--CD = 600,
				quality = 3,
				--trigger = { 61999, 20707, },
				type = HCoold.ressurect_type,
				charges = 1,
			}

function HCoold:GetSummaryRessurectSpell()
	-- HCoold:Print("Return summary in spells")
	return imbaSpell
end

function HCoold:GenerateSpellList()
	local out = {}
	local order = 1
	local t_ = {}
	local out2 = {}
	for _, i in next, spells do
		local t = tostring(i.type)
		if not out[t] then -- create group if it's not exists
			out[t] = {
				type = "group",
				cmdHidden = true,
				name = L["type"..t],
				desc = L["desc type"..t],
				order = i.type+30,
				args = {},
			}
			out2[t] = {}
			t_[t] = true
		end
		do -- spell add
			local spname = select(1, GetSpellInfo(i.spellID)) or L["No spell found"]
			local splink = select(1, GetSpellLink(i.spellID))
			local specs = ""
			local tmp = ""
			for _, j in next, i.specs do
				specs = string.format("%s%s%s",specs,tmp,j)
				tmp = ", "
			end
			local desc = function(self)
				GameTooltip:ClearLines()
				if splink then
					GameTooltip:SetHyperlink(splink)
				end
				GameTooltip:AppendText("\n")
				GameTooltip:AppendText(string.format(L["class %s specs %s"],L[i.class],L[i.class .. specs]))
				GameTooltip:AppendText("\n")
				return nil
			end
			local tt = tostring(i.spellID)
			for _,j in next, i.specs do
				tt = string.format("%s.%d",tt,j)
			end
			local s = {
				type = "toggle",
				name = spname,
				desc = desc,
				descStyle = "Toggle",
				set = function(tmp,key)
					self.db.profile.trackSpells[tt] = key
				end,
				get = function()
					return self.db.profile.trackSpells[tt]
				end,
				--order = order,
			}
			--out[t].args[tostring(order)] = s
			--order = order+1
			if not out2[t][i.class] then out2[t][i.class] = {} end
			table.insert(out2[t][i.class],s)
		end
	end
	for t, ss in next, out2 do
		out[t].args.turnoff = {
			type = "execute",
			name = L["turn all off"],
			desc = L["desc turn all off"],
			func = function() for _, i in next, out[t].args do if i.type == "toggle" then i.set(nil,false) end end end,
			order = 1,
		}
		out[t].args.turnon = {
			type = "execute",
			name = L["turn all on"],
			desc = L["desc turn all on"],
			func = function() for _, i in next, out[t].args do if i.type == "toggle" then i.set(nil,true) end end end,
			order = 2,
		}
		local count = 5
		for class, tt in next, ss do
			out[t].args[tostring(count)] = {
				type = "header",
				name = L[class],
				order = count,
			}
			count = count + 1
			for _,i in next, tt do
				i.order = count
				out[t].args[tostring(count)] = i
				count = count + 1
			end
		end
	end

	local sm = {}
	for i,j in next, self.sort_methods do sm[i] = j.desc end
	for i in next, t_ do
		local k_ = (tonumber(i) or 1)
		local k = k_ + 5
		-- self:Printf("%s",k)
		--self:Printf("%s %s %s","width" .. i,k,self.db.profile.types[k].w)
		out["header" .. i] = {
			type = "header",
			cmdHidden = true,
			name = L["header" .. i],
			order = k * 10 + 1
		}
		out["width" .. i] = {
			type = "input",
			cmdHidden = true,
			name = L["type width"..i],
			desc = L["desc type width"..i],
			order = k * 10 + 2,
			width = "half",
			set = function(a1,val)
				val = tonumber(val) or 100
				self.db.profile.types[k_].w = val
				if self.types[k_] then self.types[k_]:SetWidth(val) end
			end,
			get = function()
				return tostring(self.db.profile.types[k_].w)
			end,
		}

		out["sort" .. i] = {
			type = "select",
			-- width = "half",
			name = L["sort method" .. i],
			desc = L["desc sort method" .. i],
			order = k * 10 + 3,
			cmdHidden = true,
			values = sm,
			get = function()
				return self.db.profile.types[k_].sm
			end,
			set = function(tmp, val)
				self.db.profile.types[k_].sm = val
				if self.types[k_] then self.types[k_]:SetSortMethod(val) end
			end,
		}

		out["enable" .. i] = {
			type = "toggle",
			name = L["enable" .. i],
			desc = L["desc enable" .. i],
			order = k*10 + 4,
			cmdHidden = true,
			set = function(t, val)
				self.db.profile.types[k_].enable = val
				if self.types[k_] then self.types[k_]:Enable(val) end
			end,
			get = function() return self.db.profile.types[k_].enable end,
		}
	end

	do -- talent section
		out["auto_talent"] = {
			type = "group",
			cmdHidden = true,
			name = L["talents list"],
			desc = L["desc talents list"],
			order = 20 + 30,
			args = {},
		}
		local order = {
			["DRUID"] = 0,
			["PALADIN"] = 1,
			["PRIEST"] = 2,
			["WARLOCK"] = 3,
			["DEATHKNIGHT"] = 4,
			["MONK"] = 5,
			["HUNTER"] = 6,
			["SHAMAN"] = 7,
			["MAGE"] = 8,
			["WARRIOR"] = 9,
			["ROGUE"] = 10,
		}
		local t = out["auto_talent"].args
		t.turnoff = {
			type = "execute",
			name = L["turn all off"],
			desc = L["desc turn all off"],
			func = function() for _, i in next, t do if i.type == "toggle" then i.set(nil,false) end end end,
			order = 1,
		}
		t.turnon = {
			type = "execute",
			name = L["turn all on"],
			desc = L["desc turn all on"],
			func = function() for _, i in next, t do if i.type == "toggle" then i.set(nil,true) end end end,
			order = 2,
		}
		for class, ord in next, order do
			t["header" .. class] = {
				type = "header",
				cmdHidden = true,
				name = L[class],
				order = ord * 30 + 3,
			}
		end
		for k, i in next, list_talents do
			local tt = HCoold:TalentIndex(i)

			local spname = select(1, GetSpellInfo(i.spellID)) or L["No spell found"]
			local splink = select(1, GetSpellLink(i.spellID))
			local desc = function(self)
				GameTooltip:ClearLines()
				if splink then
					GameTooltip:SetHyperlink(splink)
				end
				-- GameTooltip:AppendText("\n")
				-- GameTooltip:AppendText(string.format(L["class %s"],L[i.class]))
				GameTooltip:AppendText(string.format(L["\ntype is %s"],L["type" .. i.type]))
				GameTooltip:AppendText("\n")
				return nil
			end
			t[tt] = {
				type = "toggle",
				name = spname,
				desc = desc,
				descStyle = "Toggle",
				set = function(tmp,key)
					self.db.profile.trackSpells[tt] = key
				end,
				get = function()
					local tmp = self.db.profile.trackSpells[tt]
					if tmp == nil then self.db.profile.trackSpells[tt] = i.turn_on end
					return self.db.profile.trackSpells[tt]
				end,
				order = order[i.class] * 30 + 5,
			}

		end
	end

	return out
end

function HCoold:RunPersonalSpellConfig() -- expert configuration
	local pspells = self.db.faction.PlayersSpells

	local f = AceGUI:Create("Frame")
	local s = AceGUI:Create("ScrollFrame")
	local AddLine = nil
	local ann_res = false
	do -- frame creation
		f:SetLayout("Fill")
		f.state = true
		f:SetCallback("OnClose",function(widget)
			f.state = false
			AceGUI:Release(widget)

			if ann_res then
				StaticPopupDialogs["HCooldRedoLayout"]= {
					text = string.format(L["Don't forget to redraw layout to aply settings."]),
					button1 = ACCEPT,
					timeout = 30,
					whileDead = 0,
					hideOnEscape = 1,
				}
				StaticPopup_Show("HCooldRedoLayout")
			end

			HCoold:RunConfig()
		end)
		f:SetTitle(L["Manual spell settings"])

		s:SetLayout("List") -- probably?
		f:AddChild(s)
	end

	do -- create tools to create spell info
		local types, types2 = {}, {}
		for _, i in next, spells do
			if not types[i.type] then
				types[i.type] = L["type" .. i.type]
				types2[i.type] = L["type" .. i.type]
			end
		end
		types[13] = L["talents"]
		--table.sort(types)

		local sg1 = AceGUI:Create("InlineGroup")
		local csg1 = AceGUI:Create("SimpleGroup")
		do -- sg1
			sg1:SetTitle(L["Add new spell options for current player."])
			sg1:SetFullWidth(true)
			sg1:SetLayout("Flow")
			sg1:SetAutoAdjustHeight(true)
			s:AddChild(sg1)
			csg1:SetFullWidth(true)
			csg1:SetLayout("Flow")
			csg1:SetAutoAdjustHeight(true)
		end

		local dd1 = AceGUI:Create("Dropdown") -- types of spell
		local dd2 = AceGUI:Create("Dropdown") -- spell list in this category
		local dd5 = AceGUI:Create("Dropdown") -- type of new spell
		local inp1 = AceGUI:Create("EditBox") -- player name
		local inp2 = AceGUI:Create("EditBox") -- CD in sec
		local inp3 = AceGUI:Create("MultiLineEditBox") -- id of spell
		local inp4 = AceGUI:Create("EditBox") -- casting time
		local inp5 = AceGUI:Create("EditBox") -- trigger event
		local dd3 = AceGUI:Create("Dropdown") -- quality of spell
		local dd4 = AceGUI:Create("Dropdown") -- spec of player to track spell
		local doit = AceGUI:Create("Button") -- button to add spell
		local values = {}
		local splist = {}
		local lines = {}
		local function onValueChanged()
			inp2:SetText()
			inp4:SetText()
			inp5:SetText()
			inp5:Fire("OnEnterPressed")
		end
		do --dd1
			-- sg1:AddChild(dd1)
			dd1:SetList(types)
			dd1:SetWidth(HCoold.config.dropdownwidth)
			dd1:SetCallback("OnValueChanged",function(_,_,key)
				splist = {}
				values = {}
				key = key or 8
				if key ~= 13 then dd5:SetValue(key) end
				dd2:SetValue()
				inp3:SetText("")
				for _, i in next, spells do
					if i.type == key then
						values[i.spellID] = select(1,GetSpellInfo(i.spellID))
						splist[i.spellID] = i
					end
				end
				if key == 13 then
					for _, i in next, list_talents do
						values[i.spellID] = select(1,GetSpellInfo(i.spellID))
						splist[i.spellID] = i
					end
				end
				dd2:SetList(values)
				onValueChanged()
			end)
			dd1:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd1.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Choose category of spell from existsing"])
				GameTooltip:Show()
			end)
			dd1:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			dd1:SetValue(8)
			dd1:Fire("OnValueChanged")
		end
		do -- dd5
			sg1:AddChild(dd5)
			dd5:SetList(types2)
			dd5:SetWidth(HCoold.config.dropdownwidth)
			dd5:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd5.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Choose spell category"])
				GameTooltip:Show()
			end)
			dd5:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			dd5:SetValue(8)
		end
		sg1:AddChild(csg1)
		do --inp3
			inp3:SetWidth(HCoold.config.editboxwidth)
			csg1:AddChild(inp3)
			inp3:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp3.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter id of spell"])
				GameTooltip:Show()
			end)
			inp3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp3:SetCallback("OnEnterPressed",function()
				--onValueChanged()
				lines = {}
				local tmp = ""
				local first = ""
				for i in string.gmatch(inp3:GetText(), "%d+") do
					table.insert(lines,tonumber(i))
					tmp = string.format("%s%s%d",tmp,first,i)
					first = "\n"
				end
				inp3:SetText(tmp)
				--HCoold:Print(inp3:GetText())
			end)
		end
		do --dd2 --------- дописать изъятие кд и прочих вещей из БД
			dd2:SetWidth(HCoold.config.dropdownwidth)
			csg1:AddChild(dd1)
			csg1:AddChild(dd2)
			dd2:SetCallback("OnValueChanged",function(_,_,key)
				onValueChanged()
				local spid = key
				if splist[key].trigger then for _, k in next, splist[key].trigger do spid = string.format("%s\n%d",spid,k) end end
				inp3:SetText(spid)
				dd5:SetValue(splist[key].type)
				inp4:SetText(splist[key].cast_time or 0)
				inp2:SetText(splist[key].CD or 0)
				inp5:SetText(splist[key].succ or "SPELL_CAST_SUCCESS")
			end)
			dd2:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd2.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Choose spell id from existsing"])
				GameTooltip:Show()
			end)
			dd2:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		do --inp1
			inp1:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp1)
			inp1:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp1.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter player name"])
				GameTooltip:Show()
			end)
			inp1:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		do --inp2
			inp2:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp2)
			inp2:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp2.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter CD of spell in sec"])
				GameTooltip:Show()
			end)
			inp2:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp2:SetCallback("OnEnterPressed",function() inp2:SetText(math.max(0,math.ceil(tonumber(inp2:GetText()) or 0))) end)
		end
		do --inp4
			inp4:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp4)
			inp4:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp4.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter casting time of spell"])
				GameTooltip:Show()
			end)
			inp4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp4:SetCallback("OnEnterPressed",function()
				local v = inp4:GetText()
				v = math.max(0,tonumber(v) or 0)
				inp4:SetText(v)
			end)
		end
		do --dd3
			sg1:AddChild(dd3)
			dd3:SetWidth(HCoold.config.dropdownwidth)
			dd3:SetList({1, 2, 3})
			dd3:SetValue(1)
			dd3:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd3.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter quality of spell"])
				GameTooltip:Show()
			end)
			dd3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		local spec_list = {"0","1","2","3","1,2","1,3","2,3","1,2,3","1,2,4","1,3,4","2,3,4"}
		do --dd4
			sg1:AddChild(dd4)
			dd4:SetList(spec_list)
			dd4:SetWidth(HCoold.config.dropdownwidth)
			dd4:SetCallback("OnValueChanged",function(_,_,key)
			end)
			dd4:SetCallback("OnEnter",function(self)
				GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
				GameTooltip:AddLine(L["Spec list by class"])
				GameTooltip:Show()
			end)
			dd4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		do --inp5
			inp5:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp5)
			inp5:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp5.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter trigger event from combat log"])
				GameTooltip:Show()
			end)
			inp5:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp5:SetCallback("OnEnterPressed",function() if inp5:GetText() == "" then inp5:SetText("SPELL_CAST_SUCCESS") end end)
			inp5:Fire("OnEnterPressed")
		end
		do --doit
			doit:SetWidth(HCoold.config.addbuttonwidth)
			doit:SetText(L["Add spell"])
			sg1:AddChild(doit)
			doit:SetCallback("OnEnter",function(self)
				inp3:Fire("OnEnterPressed")
				local splink = GetSpellLink(lines[1] or 0)
				if not splink then return end
				GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
				GameTooltip:SetHyperlink(splink)
				GameTooltip:Show()
			end)
			doit:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		doit:SetCallback("OnClick",function()
			inp2:Fire("OnEnterPressed")
			inp1:Fire("OnEnterPressed")
			inp4:Fire("OnEnterPressed")
			inp5:Fire("OnEnterPressed")
			inp3:Fire("OnEnterPressed")
			local spid, name, cd, casttime, sptype, trigger, quality = lines[1], inp1:GetText(), tonumber(inp2:GetText()) or 0, tonumber(inp4:GetText()) or 0, dd5:GetValue(),inp5:GetText(),dd3:GetValue()
			if cd > 0 and string.len(name) > 0 and spid > 0 and GetSpellInfo(spid) ~= nil then
				local spec_spec = {
					["0"] = { 0 },
					["1"] = { 1 },
					["2"] = { 2 },
					["3"] = { 3 },
					["1,2"] = { 1, 2 },
					["1,3"] = { 1, 3 },
					["2,3"] = { 2, 3 },
					["1,2,3"] = { 1, 2, 3 },
					["1,2,4"] = { 1, 2, 4 },
					["2,3,4"] = { 2, 3, 4 },
					["1,3,4"] = { 1, 3, 4 },
				}
				local i = {
					spellID = spid,
					succ = trigger,
					player = name,
					CD = cd,
					type = sptype,
					cast_time = casttime,
					specs = spec_spec[spec_list[dd4:GetValue() or 1]],
					quality = quality,
				}
				local trigg = {}
				for k = 2, #lines do
					table.insert(trigg,lines[k])
				end
				if #trigg > 0 then i.trigger = trigg end
				table.insert(pspells,i)
				ann_res = true
				AddLine(i)
				f:SetStatusText(L["Cooldown successfully added!"])
			else
				f:SetStatusText(L["You should enter spell id, player name and cooldown of spell."])
			end
		end)
	end

	do -- add List of spells
		local function deleteFromMemory(i)
			for k, j in next, pspells do
				if j == i then
					table.remove(pspells,k)
					f:SetStatusText(L["Cooldown successfulle deleted!"])
				end
			end
		end

		AddLine = function(i)
			if not i then return end
			local sg2 = AceGUI:Create("InlineGroup")
			sg2:SetLayout("Flow")
			sg2:SetFullWidth(true)
			s:AddChild(sg2)

			local spname,_, spicon = GetSpellInfo(i.spellID)
			if not spname then spname = L["Spell was deleted"] end
			local splink = GetSpellLink(i.spellID) or L["Spell was deleted"]

			local label = AceGUI:Create("InteractiveLabel")
			label:SetImageSize(21,21)
			label:SetFullWidth(true)
			label:SetImage(spicon)
			local specs = ""
			local first = nil
			if i.specs then for _, k in next, i.specs do
				if not first then first = ""
				else first = ", " end
				specs = string.format("%s%s%d",specs,first,k)
			end end
			local out = string.format(L["Spell %s(id=%d, type=%s, quality=%d, specs=%s) for player %s has CD %d sec cast time %.1f and trigger from %s."],
				splink,i.spellID,L["type" .. i.type],i.quality,specs,i.player,i.CD,i.cast_time or 0,i.succ)
			if i.trigger then
				local first, tmp = "", ""
				for _,i in next, i.trigger do
					tmp = string.format("%s%s%d",tmp,first,i)
					first = ", "
				end
				out = out .. string.format(L["another triggers are %s."], tmp)
			end
			label:SetText(out)
			label:SetCallback("OnEnter",function(self)
				GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
				if splink ~= L["Spell was deleted"] then GameTooltip:SetHyperlink(splink)
				else
					GameTooltip:AddLine(L["Spell was deleted desc"])
				end
				GameTooltip:Show()
			end)
			label:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			sg2:AddChild(label)

			local cb = AceGUI:Create("CheckBox")
			sg2:AddChild(cb)
			cb:SetValue(self.db.profile.trackManualSpells[self:ManualSpellIndex(i)])
			cb:SetWidth(HCoold.config.checkboxwidth)
			cb:SetLabel(L["Track spell"])
			cb:SetCallback("OnValueChanged",function()
				self.db.profile.trackManualSpells[self:ManualSpellIndex(i)] = cb:GetValue()
				ann_res = true
			end)

			sg2:SetTitle(string.format(L["Configuration for %s spell"],spname))
			local k = AceGUI:Create("Button")
			k:SetWidth(HCoold.config.deletebuttonwidth)
			k:SetText(L["Delete"])
			sg2:AddChild(k)
			k:SetCallback("OnClick",function()
				StaticPopupDialogs["HCooldAcceptDeleteSpell"]= {
					text = string.format(L["You realy want to delete spell %s?"],spname),
					button1 = ACCEPT,
					button2 = CANCEL,
					timeout = 30,
					whileDead = 0,
					hideOnEscape = 1,
					OnAccept = function()
						k:SetDisabled(true)
						k:SetText(L["Deleted"])
						deleteFromMemory(i)
						ann_res = true
					end,
				}
				StaticPopup_Show("HCooldAcceptDeleteSpell")
			end)
		end

		for _, i in next, pspells do AddLine(i) end
	end

	return f
end

function HCoold:GetTalentSpell(inp)
	local out = {}
	if not self.db.profile.auto_scan_talents then return out end
	if type(inp) == "string" then inp = self:GetSpec(inp) end

	-- и так у нас есть имя игрока, его класс
	-- нам надо взять таланты из памяти
	-- проверить изучил ли он их или нет
	-- включено ли отслеживание аддоном и выдать в массиве
	local t = self.db.faction.AutoTalents[inp.name]
	if t then -- у нас есть таланты по данному игроку
		local ct
		for _, k in next, class_talents do
			if k.class == inp.class then ct = k end --todo add [inp.spec]
		end
		-- проходимся по всем талантам
		for i = 1, MAX_TALENT_TIERS do
			if ct.talents[i][t.talents[i]] then -- у нас есть в базе данных этот талант
				local spell = list_talents[ct.talents[i][t.talents[i]]] -- спелл который следует добавить/не добавить
				if self.db.profile.trackSpells[self:TalentIndex(spell)] then
					-- и так, спелл отслеживается и у нашего парня есть ->
					table.insert(out,spell)
				end
			end
		end
	end

	return out
end

function HCoold:GetSpecsForClass(class)
	for _, i in next, spec_spells do
		if i.class == class then
			local out = { 0 }
			for i, _ in next, i.specs do table.insert(out, i) end
			table.sort(out)
			return out
		end
	end
end

function HCoold:GetSpellsForSpec(class, spec)
	local out = {}
	-- проверяем общие спеллы по классу
	for _, spell in next, spells do
		if spell.class == class then
			local to_add = false
			for _, i in next, spell.specs do
				if i == 0 then to_add = true end
				if i == spec then to_add = true end
			end
			if to_add then table.insert(out, spell) end
		end
	end
	-- потом добавляем таланты
	for _, spell in next, list_talents do
		if spell.class == class then table.insert(out, spell) end
	end

	return out
end












